#ifndef PARTICLEBEAM_SEEN
#define  PARTICLEBEAM_SEEN
#include <iostream>
#include <sstream>
#include <stdio.h>

#include<cmath>

#include <vector>

#include "bareParticle.h"
//#include "mathematicalTools.h"
#include "nomdElements.h"
#include "beam2Moments.h"

using namespace std;



class particleBeam 
{

  bool particleRepresentationOk_;
  bool momentRepresentationOk_;

  bareParticle referenceParticle_;

  vector<bareParticle> goodPartic_;

  beam2Moments rij_;


  vector<double> centroid_;
  double P0Transport_;


  void impressionDesMoments() const;
  void razDesMoments();


 public:

  particleBeam(); 

  virtual ~particleBeam() {;}

  void buildMomentRepresentation();


  void clear();

  int getNbParticles() const;

  const beam2Moments&  getTransportMoments() const;
  double getSigmaTransportij(unsigned i, unsigned j);
  double getUnnormalizedEmittanceX();
  double getP0Transport() const;
  double referenceKineticEnergyMeV() const;
  bool particleRepresentationOk() const;
  bool momentRepresentationOk() const;


  void  addParticle( bareParticle p);



  const vector<bareParticle>& getParticleVector() const;

  vector<bareParticle>& getParticleVector(); 

  double getXmaxRms();

  void getVariance(double& varx, double& vary, double& varz) const;
 
  void set2Moments(beam2Moments& moments);
  void setWithParticles(vector<double>& centroid, bareParticle& referencePart, vector<bareParticle>& particles);
  void printAllXYZ() const;


  void Zrange(double& zmin, double& zmax) const;

  void donneesDessinEllipseXxp(vector<double>& xcor, vector<double>& ycor);


  virtual string FileOutputFlow() const;


  virtual bool FileInput(ifstream& ifs);

  void histogramme(vector<double>&xcor,vector<int>& hist,int& cnts,double out[3]);
};


#endif
